function DefineEnv
%{
******************************************************************************************
*                                                                                        *
*    A* search with homotopy class constraints                                           *
*    Copyright (C) 2010  Subhrajit Bhattacharya                                          *
*                                                                                        *
*    This program is free software: you can redistribute it and/or modify                *
*    it under the terms of the GNU General Public License as published by                *
*    the Free Software Foundation, either version 3 of the License, or                   *
*    (at your option) any later version.                                                 *
*                                                                                        *
*    This program is distributed in the hope that it will be useful,                     *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of                      *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                       *
*    GNU General Public License for more details <http://www.gnu.org/licenses/>.         *
*                                                                                        *
*                                                                                        *
*    Contact: subhrajit@gmail.com, http://fling.seas.upenn.edu/~subhrabh/                *
*                                                                                        *
*                                                                                        *
******************************************************************************************
%}

global N M Obs z0

% Define obstacle map
N = 86;
M = 100;

% Create Rectangular obstacles

%%createRectObs([23 15; 32 40], [0 5]);
%%createRectObs([10 30; 23 40], []);

%{
createRectObs([5 5; 45 10]);
createRectObs([7 15; 20 20]);
createRectObs([25 17; 46 25]);
createRectObs([4 30; 46 38]);
createRectObs([30 40; 40 48]);
%}


% L-457
scl = 3.0;
createRectObs( [ 9.154038 32.967771; 9.154038 32.935541 ], [], scl );
createRectObs( [ 9.154038 32.935541; 8.670597 32.935541 ], [], scl );
createRectObs( [ 8.670597 32.935541; 8.670597 32.774394 ], [], scl );
createRectObs( [ 8.670597 32.774394; 8.058239 32.774394 ], [], scl );
createRectObs( [ 8.058239 32.774394; 8.058239 31.517448 ], [], scl );
createRectObs( [ 8.058239 31.517448; 8.348303 31.517448 ], [], scl );
createRectObs( [ 8.348303 31.517448; 8.348303 26.392973 ], [], scl );
createRectObs( [ 8.348303 26.392973; 8.154927 26.392973 ], [], scl );
createRectObs( [ 8.154927 26.392973; 8.154927 30.196042 ], [], scl );
createRectObs( [ 8.154927 30.196042; 4.899757 30.196042 ], [], scl );
createRectObs( [ 4.899757 30.196042; 4.899757 29.873748 ], [], scl );
createRectObs( [ 4.899757 29.873748; 4.770840 29.873748 ], [], scl );
createRectObs( [ 4.770840 29.873748; 4.770840 25.587238 ], [], scl );
createRectObs( [ 4.770840 25.587238; 7.252504 25.587238 ], [], scl );
createRectObs( [ 7.252504 25.587238; 7.252504 25.651697 ], [], scl );
createRectObs( [ 7.252504 25.651697; 8.348303 25.651697 ], [], scl );
createRectObs( [ 8.348303 25.651697; 8.348303 25.297173 ], [], scl );
createRectObs( [ 8.348303 25.297173; 8.154927 25.297173 ], [], scl );
createRectObs( [ 8.154927 25.297173; 8.154927 25.329403 ], [], scl );
createRectObs( [ 8.154927 25.329403; 7.252504 25.329403 ], [], scl );
createRectObs( [ 7.252504 25.329403; 7.252504 25.361632 ], [], scl );
createRectObs( [ 7.252504 25.361632; 4.770840 25.361632 ], [], scl );
createRectObs( [ 4.770840 25.361632; 4.770840 21.010663 ], [], scl );
createRectObs( [ 4.770840 21.010663; 4.899757 21.010663 ], [], scl );
createRectObs( [ 4.899757 21.010663; 4.899757 20.720599 ], [], scl );
createRectObs( [ 4.899757 20.720599; 8.154927 20.720599 ], [], scl );
createRectObs( [ 8.154927 20.720599; 8.154927 24.523668 ], [], scl );
createRectObs( [ 8.154927 24.523668; 8.348303 24.523668 ], [], scl );
createRectObs( [ 8.348303 24.523668; 8.348303 16.788612 ], [], scl );
createRectObs( [ 8.348303 16.788612; 8.154927 16.788612 ], [], scl );
createRectObs( [ 8.154927 16.788612; 8.154927 20.527222 ], [], scl );
createRectObs( [ 8.154927 20.527222; 4.899757 20.527222 ], [], scl );
createRectObs( [ 4.899757 20.527222; 4.899757 20.237158 ], [], scl );
createRectObs( [ 4.899757 20.237158; 4.803069 20.237158 ], [], scl );
createRectObs( [ 4.803069 20.237158; 4.803069 15.950647 ], [], scl );
createRectObs( [ 4.803069 15.950647; 8.187156 15.950647 ], [], scl );
createRectObs( [ 8.187156 15.950647; 8.187156 16.015106 ], [], scl );
createRectObs( [ 8.187156 16.015106; 8.380533 16.015106 ], [], scl );
createRectObs( [ 8.380533 16.015106; 8.380533 15.692812 ], [], scl );
createRectObs( [ 8.380533 15.692812; 8.122697 15.692812 ], [], scl );
createRectObs( [ 8.122697 15.692812; 8.122697 15.757271 ], [], scl );
createRectObs( [ 8.122697 15.757271; 4.803069 15.757271 ], [], scl );
createRectObs( [ 4.803069 15.757271; 4.803069 11.116237 ], [], scl );
createRectObs( [ 4.803069 11.116237; 8.154927 11.116237 ], [], scl );
createRectObs( [ 8.154927 11.116237; 8.154927 14.951536 ], [], scl );
createRectObs( [ 8.154927 14.951536; 8.380533 14.951536 ], [], scl );
createRectObs( [ 8.380533 14.951536; 8.380533 9.794832 ], [], scl );
createRectObs( [ 8.380533 9.794832; 7.252504 9.794832 ], [], scl );
createRectObs( [ 7.252504 9.794832; 7.252504 9.762603 ], [], scl );
createRectObs( [ 7.252504 9.762603; 5.737722 9.762603 ], [], scl );
createRectObs( [ 5.737722 9.762603; 5.737722 9.730373 ], [], scl );
createRectObs( [ 5.737722 9.730373; 5.512116 9.730373 ], [], scl );
createRectObs( [ 5.512116 9.730373; 5.512116 9.762603 ], [], scl );
createRectObs( [ 5.512116 9.762603; 1.032229 9.762603 ], [], scl );
createRectObs( [ 1.032229 9.762603; 1.032229 5.991763 ], [], scl );
createRectObs( [ 1.032229 5.991763; 3.836187 5.991763 ], [], scl );
createRectObs( [ 3.836187 5.991763; 3.836187 6.410745 ], [], scl );
createRectObs( [ 3.836187 6.410745; 4.674152 6.410745 ], [], scl );
createRectObs( [ 4.674152 6.410745; 4.674152 8.376738 ], [], scl );
createRectObs( [ 4.674152 8.376738; 5.512116 8.376738 ], [], scl );
createRectObs( [ 5.512116 8.376738; 5.512116 8.892409 ], [], scl );
createRectObs( [ 5.512116 8.892409; 5.737722 8.892409 ], [], scl );
createRectObs( [ 5.737722 8.892409; 5.737722 8.408968 ], [], scl );
createRectObs( [ 5.737722 8.408968; 6.317851 8.408968 ], [], scl );
createRectObs( [ 6.317851 8.408968; 6.317851 7.861068 ], [], scl );
createRectObs( [ 6.317851 7.861068; 5.189822 7.861068 ], [], scl );
createRectObs( [ 5.189822 7.861068; 5.189822 2.317611 ], [], scl );
createRectObs( [ 5.189822 2.317611; 5.673263 1.834170 ], [], scl );
createRectObs( [ 5.673263 1.834170; 6.317851 1.834170 ], [], scl );
createRectObs( [ 6.317851 1.834170; 6.317851 1.801941 ], [], scl );
createRectObs( [ 6.317851 1.801941; 6.865751 1.801941 ], [], scl );
createRectObs( [ 6.865751 1.801941; 6.865751 1.834170 ], [], scl );
createRectObs( [ 6.865751 1.834170; 7.639256 1.834170 ], [], scl );
createRectObs( [ 7.639256 1.834170; 7.639256 1.801941 ], [], scl );
createRectObs( [ 7.639256 1.801941; 8.219386 1.801941 ], [], scl );
createRectObs( [ 8.219386 1.801941; 8.219386 1.834170 ], [], scl );
createRectObs( [ 8.219386 1.834170; 15.213165 1.834170 ], [], scl );
createRectObs( [ 15.213165 1.834170; 15.213165 1.866400 ], [], scl );
createRectObs( [ 15.213165 1.866400; 15.438771 1.866400 ], [], scl );
createRectObs( [ 15.438771 1.866400; 15.438771 1.834170 ], [], scl );
createRectObs( [ 15.438771 1.834170; 16.018900 1.834170 ], [], scl );
createRectObs( [ 16.018900 1.834170; 16.018900 1.866400 ], [], scl );
createRectObs( [ 16.018900 1.866400; 16.760177 1.866400 ], [], scl );
createRectObs( [ 16.760177 1.866400; 16.760177 1.834170 ], [], scl );
createRectObs( [ 16.760177 1.834170; 17.340306 1.834170 ], [], scl );
createRectObs( [ 17.340306 1.834170; 17.340306 1.866400 ], [], scl );
createRectObs( [ 17.340306 1.866400; 20.788852 1.866400 ], [], scl );
createRectObs( [ 20.788852 1.866400; 20.788852 4.767046 ], [], scl );
createRectObs( [ 20.788852 4.767046; 22.078028 4.767046 ], [], scl );
createRectObs( [ 22.078028 4.767046; 22.078028 1.963088 ], [], scl );
createRectObs( [ 22.078028 1.963088; 25.043132 1.963088 ], [], scl );
createRectObs( [ 25.043132 1.963088; 25.043132 6.023992 ], [], scl );
createRectObs( [ 25.043132 6.023992; 24.301856 6.023992 ], [], scl );
createRectObs( [ 24.301856 6.023992; 24.301856 7.957756 ], [], scl );
createRectObs( [ 24.301856 7.957756; 23.141598 7.957756 ], [], scl );
createRectObs( [ 23.141598 7.957756; 23.141598 8.473427 ], [], scl );
createRectObs( [ 23.141598 8.473427; 24.656380 8.473427 ], [], scl );
createRectObs( [ 24.656380 8.473427; 24.656380 8.376738 ], [], scl );
createRectObs( [ 24.656380 8.376738; 25.719950 8.376738 ], [], scl );
createRectObs( [ 25.719950 8.376738; 25.719950 7.893297 ], [], scl );
createRectObs( [ 25.719950 7.893297; 27.589255 7.893297 ], [], scl );
createRectObs( [ 27.589255 7.893297; 27.589255 9.955979 ], [], scl );
createRectObs( [ 27.589255 9.955979; 26.171161 9.955979 ], [], scl );
createRectObs( [ 26.171161 9.955979; 26.171161 9.923750 ], [], scl );
createRectObs( [ 26.171161 9.923750; 25.558803 9.923750 ], [], scl );
createRectObs( [ 25.558803 9.923750; 25.558803 9.955979 ], [], scl );
createRectObs( [ 25.558803 9.955979; 24.656380 9.955979 ], [], scl );
createRectObs( [ 24.656380 9.955979; 24.656380 9.827061 ], [], scl );
createRectObs( [ 24.656380 9.827061; 23.334974 9.827061 ], [], scl );
createRectObs( [ 23.334974 9.827061; 23.334974 9.794832 ], [], scl );
createRectObs( [ 23.334974 9.794832; 22.819304 9.794832 ], [], scl );
createRectObs( [ 22.819304 9.794832; 22.819304 9.891520 ], [], scl );
createRectObs( [ 22.819304 9.891520; 22.303633 9.891520 ], [], scl );
createRectObs( [ 22.303633 9.891520; 22.303633 9.794832 ], [], scl );
createRectObs( [ 22.303633 9.794832; 18.532794 9.794832 ], [], scl );
createRectObs( [ 18.532794 9.794832; 18.532794 14.951536 ], [], scl );
createRectObs( [ 18.532794 14.951536; 18.726170 14.951536 ], [], scl );
createRectObs( [ 18.726170 14.951536; 18.726170 14.758160 ], [], scl );
createRectObs( [ 18.726170 14.758160; 18.693941 14.758160 ], [], scl );
createRectObs( [ 18.693941 14.758160; 18.693941 11.148467 ], [], scl );
createRectObs( [ 18.693941 11.148467; 21.884651 11.148467 ], [], scl );
createRectObs( [ 21.884651 11.148467; 21.884651 14.790389 ], [], scl );
createRectObs( [ 21.884651 14.790389; 21.916881 14.790389 ], [], scl );
createRectObs( [ 21.916881 14.790389; 21.916881 15.531665 ], [], scl );
createRectObs( [ 21.916881 15.531665; 21.594587 15.531665 ], [], scl );
createRectObs( [ 21.594587 15.531665; 21.594587 15.563895 ], [], scl );
createRectObs( [ 21.594587 15.563895; 21.368981 15.563895 ], [], scl );
createRectObs( [ 21.368981 15.563895; 21.368981 15.789500 ], [], scl );
createRectObs( [ 21.368981 15.789500; 19.628593 15.789500 ], [], scl );
createRectObs( [ 19.628593 15.789500; 19.628593 15.692812 ], [], scl );
createRectObs( [ 19.628593 15.692812; 18.661711 15.692812 ], [], scl );
createRectObs( [ 18.661711 15.692812; 18.661711 15.725042 ], [], scl );
createRectObs( [ 18.661711 15.725042; 18.532794 15.725042 ], [], scl );
createRectObs( [ 18.532794 15.725042; 18.532794 16.015106 ], [], scl );
createRectObs( [ 18.532794 16.015106; 19.628593 16.015106 ], [], scl );
createRectObs( [ 19.628593 16.015106; 19.628593 15.982877 ], [], scl );
createRectObs( [ 19.628593 15.982877; 21.368981 15.982877 ], [], scl );
createRectObs( [ 21.368981 15.982877; 21.368981 16.272941 ], [], scl );
createRectObs( [ 21.368981 16.272941; 21.916881 16.272941 ], [], scl );
createRectObs( [ 21.916881 16.272941; 21.916881 19.141358 ], [], scl );
createRectObs( [ 21.916881 19.141358; 21.884651 19.141358 ], [], scl );
createRectObs( [ 21.884651 19.141358; 21.884651 20.559452 ], [], scl );
createRectObs( [ 21.884651 20.559452; 18.726170 20.559452 ], [], scl );
createRectObs( [ 18.726170 20.559452; 18.726170 16.820841 ], [], scl );
createRectObs( [ 18.726170 16.820841; 18.500564 16.820841 ], [], scl );
createRectObs( [ 18.500564 16.820841; 18.500564 24.523668 ], [], scl );
createRectObs( [ 18.500564 24.523668; 18.693941 24.523668 ], [], scl );
createRectObs( [ 18.693941 24.523668; 18.693941 20.752828 ], [], scl );
createRectObs( [ 18.693941 20.752828; 21.884651 20.752828 ], [], scl );
createRectObs( [ 21.884651 20.752828; 21.884651 25.393862 ], [], scl );
createRectObs( [ 21.884651 25.393862; 18.693941 25.393862 ], [], scl );
createRectObs( [ 18.693941 25.393862; 18.693941 25.329403 ], [], scl );
createRectObs( [ 18.693941 25.329403; 18.468335 25.329403 ], [], scl );
createRectObs( [ 18.468335 25.329403; 18.468335 25.651697 ], [], scl );
createRectObs( [ 18.468335 25.651697; 18.661711 25.651697 ], [], scl );
createRectObs( [ 18.661711 25.651697; 18.661711 25.587238 ], [], scl );
createRectObs( [ 18.661711 25.587238; 21.884651 25.587238 ], [], scl );
createRectObs( [ 21.884651 25.587238; 21.884651 30.196042 ], [], scl );
createRectObs( [ 21.884651 30.196042; 18.661711 30.196042 ], [], scl );
createRectObs( [ 18.661711 30.196042; 18.661711 26.425202 ], [], scl );
createRectObs( [ 18.661711 26.425202; 18.468335 26.425202 ], [], scl );
createRectObs( [ 18.468335 26.425202; 18.468335 31.517448 ], [], scl );
createRectObs( [ 18.468335 31.517448; 21.884651 31.517448 ], [], scl );
createRectObs( [ 21.884651 31.517448; 21.884651 31.581906 ], [], scl );
createRectObs( [ 21.884651 31.581906; 21.723504 31.581906 ], [], scl );
createRectObs( [ 21.723504 31.581906; 21.723504 32.838853 ], [], scl );
createRectObs( [ 21.723504 32.838853; 21.594587 32.838853 ], [], scl );
createRectObs( [ 21.594587 32.838853; 21.594587 32.935541 ], [], scl );
createRectObs( [ 21.594587 32.935541; 18.693941 32.935541 ], [], scl );
createRectObs( [ 18.693941 32.935541; 18.693941 32.645477 ], [], scl );
createRectObs( [ 18.693941 32.645477; 16.502341 32.645477 ], [], scl );
createRectObs( [ 16.502341 32.645477; 16.502341 32.709935 ], [], scl );
createRectObs( [ 16.502341 32.709935; 16.405653 32.709935 ], [], scl );
createRectObs( [ 16.405653 32.709935; 16.405653 32.935541 ], [], scl );
createRectObs( [ 16.405653 32.935541; 9.734167 32.935541 ], [], scl );
createRectObs( [ 9.734167 32.935541; 9.734167 32.967771 ], [], scl );
createRectObs( [ 9.734167 32.967771; 9.154038 32.967771 ], [], scl );
createRectObs( [ 9.798626 31.485218; 9.798626 26.715267 ], [], scl );
createRectObs( [ 9.798626 26.715267; 9.927544 26.715267 ], [], scl );
createRectObs( [ 9.927544 26.715267; 9.927544 30.228272 ], [], scl );
createRectObs( [ 9.927544 30.228272; 13.343860 30.228272 ], [], scl );
createRectObs( [ 13.343860 30.228272; 13.343860 23.105574 ], [], scl );
createRectObs( [ 13.343860 23.105574; 9.927544 23.105574 ], [], scl );
createRectObs( [ 9.927544 23.105574; 9.927544 25.845073 ], [], scl );
createRectObs( [ 9.927544 25.845073; 9.798626 25.845073 ], [], scl );
createRectObs( [ 9.798626 25.845073; 9.798626 22.976657 ], [], scl );
createRectObs( [ 9.798626 22.976657; 17.018012 22.976657 ], [], scl );
createRectObs( [ 17.018012 22.976657; 17.018012 25.877303 ], [], scl );
createRectObs( [ 17.018012 25.877303; 16.889094 25.877303 ], [], scl );
createRectObs( [ 16.889094 25.877303; 16.889094 23.105574 ], [], scl );
createRectObs( [ 16.889094 23.105574; 13.472778 23.105574 ], [], scl );
createRectObs( [ 13.472778 23.105574; 13.472778 30.228272 ], [], scl );
createRectObs( [ 13.472778 30.228272; 16.889094 30.228272 ], [], scl );
createRectObs( [ 16.889094 30.228272; 16.889094 26.715267 ], [], scl );
createRectObs( [ 16.889094 26.715267; 17.018012 26.715267 ], [], scl );
createRectObs( [ 17.018012 26.715267; 17.018012 31.485218 ], [], scl );
createRectObs( [ 17.018012 31.485218; 9.798626 31.485218 ], [], scl );
createRectObs( [ 9.830856 18.335623; 9.830856 15.499436 ], [], scl );
createRectObs( [ 9.830856 15.499436; 9.959773 15.499436 ], [], scl );
createRectObs( [ 9.959773 15.499436; 9.959773 18.206705 ], [], scl );
createRectObs( [ 9.959773 18.206705; 13.376090 18.206705 ], [], scl );
createRectObs( [ 13.376090 18.206705; 13.376090 11.116237 ], [], scl );
createRectObs( [ 13.376090 11.116237; 9.959773 11.116237 ], [], scl );
createRectObs( [ 9.959773 11.116237; 9.959773 14.597013 ], [], scl );
createRectObs( [ 9.959773 14.597013; 9.830856 14.597013 ], [], scl );
createRectObs( [ 9.830856 14.597013; 9.830856 9.827061 ], [], scl );
createRectObs( [ 9.830856 9.827061; 17.050241 9.827061 ], [], scl );
createRectObs( [ 17.050241 9.827061; 17.050241 14.629242 ], [], scl );
createRectObs( [ 17.050241 14.629242; 16.921324 14.629242 ], [], scl );
createRectObs( [ 16.921324 14.629242; 16.921324 11.116237 ], [], scl );
createRectObs( [ 16.921324 11.116237; 13.505007 11.116237 ], [], scl );
createRectObs( [ 13.505007 11.116237; 13.505007 18.206705 ], [], scl );
createRectObs( [ 13.505007 18.206705; 16.921324 18.206705 ], [], scl );
createRectObs( [ 16.921324 18.206705; 16.921324 15.467206 ], [], scl );
createRectObs( [ 16.921324 15.467206; 17.050241 15.467206 ], [], scl );
createRectObs( [ 17.050241 15.467206; 17.050241 18.335623 ], [], scl );
createRectObs( [ 17.050241 18.335623; 9.830856 18.335623 ], [], scl );
createRectObs( [ 7.155815 8.376738; 7.155815 7.925527 ], [], scl );
createRectObs( [ 7.155815 7.925527; 18.017123 7.925527 ], [], scl );
createRectObs( [ 18.017123 7.925527; 18.017123 7.957756 ], [], scl );
createRectObs( [ 18.017123 7.957756; 21.497898 7.957756 ], [], scl );
createRectObs( [ 21.497898 7.957756; 21.497898 8.408968 ], [], scl );
createRectObs( [ 21.497898 8.408968; 12.248061 8.408968 ], [], scl );
createRectObs( [ 12.248061 8.408968; 12.248061 8.376738 ], [], scl );
createRectObs( [ 12.248061 8.376738; 7.155815 8.376738 ], [], scl );

z0 = [41+44*i; 40+81*i];


% ==================================================================

function createRectObs(p, zetaOffset, obsScale)
% p = [x1 y1; x2 y2];
global Obs z0

if nargin<3
    obsScale = 1;
end
p = round(p*obsScale);

[xObs, yObs] = meshgrid(min(p(:,1)):max(p(:,1)), min(p(:,2)):max(p(:,2)));
xObs = xObs(:);
yObs = yObs(:);
Obs = [Obs; [xObs, yObs]];

if nargin<2
    zetaOffset = 0;
elseif ~isempty(zetaOffset)
    zetaOffset = zetaOffset(1) + i*zetaOffset(2);
end
z0 = [z0; mean(xObs)+i*(mean(yObs)) + zetaOffset];
